Subject: Re: bug#46537: ‘uname -s’ from Gash-Utils-Boot returns nothing

From: Ludovic Courtès <[email-masked]>
Date: Thu, 18 Feb 2021 14:34:51 +0100

Hi!

Timothy Sample <[email-masked]> skribis:

> Efraim Flashner <[email-masked]> writes:
>
>> On Wed, Feb 17, 2021 at 04:16:29PM +0100, Ludovic Courtès wrote:
>>>
>>> Efraim Flashner <[email-masked]> skribis:
>>> 
>>> > On Mon, Feb 15, 2021 at 06:24:46PM +0100, Ludovic Courtès wrote:
>>> >> Gash-Utils ‘uname’ seems to be confused:
>>> >> 
>>> >> --8<---------------cut here---------------start------------->8---
>>> >> $ $(guix build -e '(@@ (gnu packages commencement) gash-utils-boot)')/bin/uname -a
>>> >> Linux ribbon 5.10.10-gnu #1 SMP 1 x86_64 GNU/Linux
>>> >> $ $(guix build -e '(@@ (gnu packages commencement) gash-utils-boot)')/bin/uname -s
>>> >> 
>>> >> $ guix describe
>>> >> Generacio 175	Feb 04 2021 22:52:40	(nuna)
>>> >>   guix 5ae09d7
>>> >>     repository URL: https://git.savannah.gnu.org/git/guix.git
>>> >>     branch: master
>>> >>     commit: 5ae09d7979a0696d862b9555314eab199f7ce576

[...]

> Indeed!  I noticed this same issue the other day.  Check out commit
> 2ee2e2721367cc242ceb0e4b364468870a87f0b4:
>
>     https://git.savannah.nongnu.org/cgit/gash/gash-utils.git/commit/?id=2ee2e2721367cc242ceb0e4b364468870a87f0b4

Great!

> I recommend that you take a look at the “wip-gcc-mesboot” branch.  It
> has a couple “from the hip” changes that I made while looking at getting
> Gash-Utils to handle more of the work in “commencement.scm”.  Last week
> I was able to build to “gcc-mesboot1” with only Make, Diffutils, patch,
> and Gzip (the first three were there before the “Scheme-only” bootstrap,
> and Gzip saves writing “(delete 'compress-documentation)” over and
> over).

We should add a pure Scheme gzip implementation, for instance using the
R6RS zlib implementation by Göran Weinholt in Industria.

> Unfortunately, building Glibc after that is quite difficult.  To do it
> with Gash-Utils, we would need (at least) to support redirects in AWK
> and the “-t” and “-k” flags in sort.  For fun, I tried building Gawk
> and Coreutils at this point (using the ancient versions that we
> bootstrap with now).  That let me build Glibc, but then I hit a
> problem with the “po2test.sed” script while building “gcc-mesboot”.  I
> tried again with ancient GNU Sed, but the build seemed to hang during
> a configure test.  I suspect adding Bash to the mix might fix it, but
> I haven’t tried yet....

Heheh, nice!  Anyhow, that looks like a promising path to me.

> Back to the matter at hand: I’m closing this bug since it’s already been
> fixed.  :)

Thanks!  Any plan for a release?  We could upgrade the package in
‘core-updates’.

Ludo’.